/* z.c v0.80 */
/* EB = Edward Boone */
/* epsilonbeta@geocities.com */
/* http://www.geocities.com/SiliconValley/Vista/6617/index.html */
/* Only nothing seems to be what it looks like */
/*---------------------------------------------------------------------------*/
/* #include */
#include "specific.h"
/*---------------------------------------------------------------------------*/
/* #define */
#define DELAY_MIN 0
#define DELAY_MAX 3000
#define DELAY_STEP 100

#define SORT_MIN 1
#define SORT_MAX 10
#define SORT_STEP 1
/*---------------------------------------------------------------------------*/
/* variables */
int delayy;

static tkeyparse
  see_f10_0 = {K_0, keysee_f10_0}, /* z.c specific */
  see_f10_1 = {K_1, keysee_f10_1},
  see_f10_2 = {K_2, keysee_f10_2},
  see_f10_3 = {K_3, keysee_f10_3},
  see_f10_4 = {K_4, keysee_f10_4},
  see_f10_5 = {K_5, keysee_f10_5},
  see_f10_6 = {K_6, keysee_f10_6},
  see_f10_7 = {K_7, keysee_f10_7},
  see_f10_8 = {K_8, keysee_f10_8},
  see_f10_9 = {K_9, keysee_f10_9},
  see_f10_A = {K_A, keysee_f10_A},
  see_f10_D = {K_D, keysee_f10_D},
  see_f10_a = {K_a, keysee_f10_a},
  see_f10_d = {K_d, keysee_f10_d}
;

tkeyparse* tkeyparsetbl_z[] =
{
  TKEYPARSETBL_SEE, /* see.c specific */
  &see_f10_0, /* z.c specific */
  &see_f10_1,
  &see_f10_2,
  &see_f10_3,
  &see_f10_4,
  &see_f10_5,
  &see_f10_6,
  &see_f10_7,
  &see_f10_8,
  &see_f10_9,
  &see_f10_A,
  &see_f10_D,
  &see_f10_a,
  &see_f10_d,
  NULL
};

teffect eff_z =
{
  z_init,
  z_effect,
  z_loop_end,
  z_done,
  tkeyparsetbl_z,
  1
};
/*---------------------------------------------------------------------------*/
int z_loop_end()
{
  switch (lastkey)
    {
    COMMON_LOOP_END
    case K_A:
    case K_D:
    case K_a:
    case K_d:
      return 0;
      break;
    default:
      return 1;
      break;
    }
}
/*---------------------------------------------------------------------------*/
void bleed()
{
  pbleed(0, 0, pbmp, 10, 2, FALSE);
  rest(delayy);
  clear(screen);
  key_scan();
}
/*---------------------------------------------------------------------------*/
void flip()
{
  draw_sprite(screen, pbmp, 0, 0);
  rest(delayy);
  draw_sprite_v_flip(screen, pbmp, 0, 0);
  rest(delayy);
  draw_sprite_vh_flip(screen, pbmp, 0, 0);
  rest(delayy);
  draw_sprite_h_flip(screen, pbmp, 0, 0);
  rest(delayy);
  key_scan();
}
/*---------------------------------------------------------------------------*/
void keysee_f10_0()
{
  keysee_f10_gen("f10_0");
}
/*---------------------------------------------------------------------------*/
void keysee_f10_1()
{
  keysee_f10_gen("f10_1");
}
/*---------------------------------------------------------------------------*/
void keysee_f10_2()
{
  keysee_f10_gen("f10_2");
}
/*---------------------------------------------------------------------------*/
void keysee_f10_3()
{
  keysee_f10_gen("f10_3");
}
/*---------------------------------------------------------------------------*/
void keysee_f10_4()
{
  keysee_f10_gen("f10_4");
}
/*---------------------------------------------------------------------------*/
void keysee_f10_5()
{
  keysee_f10_gen("f10_5");
}
/*---------------------------------------------------------------------------*/
void keysee_f10_6()
{
  keysee_f10_gen("f10_6");
}
/*---------------------------------------------------------------------------*/
void keysee_f10_7()
{
  keysee_f10_gen("f10_7");
}
/*---------------------------------------------------------------------------*/
void keysee_f10_8()
{
  keysee_f10_gen("f10_8");
}
/*---------------------------------------------------------------------------*/
void keysee_f10_9()
{
  keysee_f10_gen("f10_9");
}
/*---------------------------------------------------------------------------*/
void keysee_f10_A()
{
  paraint(&eff_z.asort, SORT_MIN, SORT_MAX, SORT_STEP, 1, 1);
}
/*---------------------------------------------------------------------------*/
void keysee_f10_D()
{
  paraint(&delayy, DELAY_MIN, DELAY_MAX, DELAY_STEP, 1, 0);
}
/*---------------------------------------------------------------------------*/
void keysee_f10_a()
{
  paraint(&eff_z.asort, SORT_MIN, SORT_MAX, SORT_STEP, 0, 1);
}
/*---------------------------------------------------------------------------*/
void keysee_f10_d()
{
  paraint(&delayy, DELAY_MIN, DELAY_MAX, DELAY_STEP, 0, 0);
}
/*---------------------------------------------------------------------------*/
void keysee_f10_gen(uchr s[256])
{
  int pi;
  char **tps;

  tps = get_config_argv("[See]", s, &pi);
  eff_z.asort = atoi(tps[1]);
  delayy = atoi(tps[2]);
  do_effect(&eff_z);
}
/*---------------------------------------------------------------------------*/
void shaker()
{
  pshake(0, 0, pbmp, 10, 20, 100, FALSE);
  key_scan();
}
/*---------------------------------------------------------------------------*/
void spiral()
{
  pspiralin(0, 0, pbmp, 10, 5, FALSE);
  rest(delayy);
  clear(screen);
  pspiralout(0, 0, pbmp, 10, 5, FALSE);
  rest(delayy);
  clear(screen);
  key_scan();
}
/*---------------------------------------------------------------------------*/
void twist()
{
  draw_sprite(screen, pbmp, 0, 0);
  rest(delayy);
  draw_sprite_h_flip(screen, pbmp, 0, 0);
  rest(delayy);
  key_scan();
}
/*---------------------------------------------------------------------------*/
void wiperh()
{
  pwipelefttoright(0, 0, pbmp, 1, FALSE);
  rest(delayy);
  clear(screen);
  pwiperighttoleft(0, 0, pbmp, 1, FALSE);
  rest(delayy);
  clear(screen);
  key_scan();
}
/*---------------------------------------------------------------------------*/
void wiperh2()
{
  pwipetocentrevertically(0, 0, pbmp, 1, FALSE);
  rest(delayy);
  clear(screen);
  pwipefromcentrevertically(0, 0, pbmp, 1, FALSE);
  rest(delayy);
  clear(screen);
  key_scan();
}
/*---------------------------------------------------------------------------*/
void wiperv()
{
  pwipetoptobottom(0, 0, pbmp, 1, FALSE);
  rest(delayy);
  clear(screen);
  pwipebottomtotop(0, 0, pbmp, 1, FALSE);
  rest(delayy);
  clear(screen);
  key_scan();
}
/*---------------------------------------------------------------------------*/
void wiperv2()
{
  pwipetocentrehorizontally(0, 0, pbmp, 1, FALSE);
  rest(delayy);
  clear(screen);
  pwipefromcentrehorizontally(0, 0, pbmp, 1, FALSE);
  rest(delayy);
  clear(screen);
  key_scan();
}
/*---------------------------------------------------------------------------*/
void z_done()
{
}
/*---------------------------------------------------------------------------*/
void z_effect(int asort)
{
  switch (asort)
    {
    case 1:
      bleed();
      break;
    case 2:
      flip();
      break;
    case 3:
      shaker();
      break;
    case 4:
      spiral();
      break;
    case 5:
      wiperh();
      break;
    case 6:
      wiperh2();
      break;
    case 7:
      wiperv();
      break;
    case 8:
      wiperv2();
      break;
    case 9:
      twist();
      break;
    case 10:
      zap();
      break;
    }
}
/*---------------------------------------------------------------------------*/
void z_init()
{
  lastkey = K_d;
}
/*---------------------------------------------------------------------------*/
void zap()
{
  ppushzap(0, 0, pbmp, 8);
  rest(delayy);
  clear(screen);
  poverwritezap(0, 0, pbmp, 1, FALSE);
  rest(delayy);
  clear(screen);
  key_scan();
}
